<template>
  <div class="app-container">
    <!-- <h1>auditFail 审课失败</h1> -->
    <el-card class="filter-container" shadow="never">
      <div>
        <i class="el-icon-search"></i>
        <span>筛选搜索</span>
        <el-button
          style="float: right"
          @click="handleSearchList()"
          type="primary"
          size="small"
        >
          查询结果
        </el-button>
        <el-button
          style="float: right; margin-right: 15px"
          @click="handleResetSearch('listQuery')"
          size="small"
        >
          重置
        </el-button>
      </div>
      <div style="margin-top: 15px">
        <el-form
          :inline="true"
          :model="listQuery"
          ref="listQuery"
          size="small"
          label-width="140px"
          @keyup.enter.native="handleSearchList()"
        >
          <el-form-item label="录入时间：" prop="inputTime">
            <el-date-picker
              v-model="inputTime"
              type="daterange"
              align="right"
              unlink-panels
              range-separator="至"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              value-format="yyyy-MM-dd HH:mm:ss"
              :default-time="['00:00:00', '23:59:59']"
              :picker-options="pickerOptions"
            >
            </el-date-picker>
          </el-form-item>

          <el-form-item label="提交日期：" prop="submitTime">
            <el-date-picker
              v-model="submitTime"
              type="daterange"
              align="right"
              unlink-panels
              range-separator="至"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              value-format="yyyy-MM-dd HH:mm:ss"
              :default-time="['00:00:00', '23:59:59']"
              :picker-options="pickerOptions"
            >
            </el-date-picker>
          </el-form-item>
          <el-form-item label="缴费日期：" prop="paymentTime">
            <el-date-picker
              v-model="paymentTime"
              type="daterange"
              align="right"
              unlink-panels
              range-separator="至"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
              value-format="yyyy-MM-dd HH:mm:ss"
              :default-time="['00:00:00', '23:59:59']"
              :picker-options="pickerOptions"
            >
            </el-date-picker>
          </el-form-item>
        </el-form>
      </div>
    </el-card>

    <div class="table-container">
      <el-table
        ref="productTable"
        :data="list"
        style="width: 100%"
        @selection-change="handleSelectionChange"
        v-loading="listLoading"
        border
        @sort-change="changeTableSort"
      >
        <!-- <el-table-column
              type="selection"
              width="60"
              align="center"
            ></el-table-column> -->
        <el-table-column label="姓名" align="center">
          <template slot-scope="scope">
            <div
              class="handleStuDetail"
              @click="handleStuDetail(scope.row.userId)"
            >
              {{ scope.row.nameCn }}
            </div>
          </template>
        </el-table-column>
        <el-table-column label="性别" align="center">
          <template slot-scope="scope">{{
            scope.row.sex == 0 ? "女" : "男"
          }}</template>
        </el-table-column>

        <el-table-column label="缴费状态" align="center">
          <template slot-scope="scope">{{
            scope.row.status == 1
              ? "定金"
              : scope.row.status == 2
              ? "补全费用"
              : "全款"
          }}</template>
        </el-table-column>

        <el-table-column label="渠道" align="center">
          <template slot-scope="scope">{{
            scope.row.channel == 1
              ? "转介"
              : scope.row.channel == 2
              ? "活动"
              : ""
          }}</template>
        </el-table-column>

        <el-table-column label="校园大使" align="center">
          <template slot-scope="scope">{{ scope.row.campusAgent }}</template>
        </el-table-column>

        <el-table-column label="微信号" align="center">
          <template slot-scope="scope">{{ scope.row.wechatNumber }}</template>
        </el-table-column>

        <el-table-column label="所在学校" align="center">
          <template slot-scope="scope">{{ scope.row.school }}</template>
        </el-table-column>

        <!-- <el-table-column
          label="分配时间"
          :sortable="'custom'"
          align="center"
          prop="nextChatTime"
        >
          <template slot-scope="scope">{{
            scope.row.studyCareAllocateTime
          }}</template>
        </el-table-column> -->

        <el-table-column
          label="缴费时间"
          :sortable="'custom'"
          align="center"
          prop="addTime"
        >
          <template slot-scope="scope">{{
            scope.row.addTime | formatDateTime
          }}</template>
        </el-table-column>

        <el-table-column
          label="审课失败时间"
          :sortable="'custom'"
          align="center"
          prop="commitTime"
        >
          <template slot-scope="scope">{{
            scope.row.commitTime | formatDateTime
          }}</template>
        </el-table-column>

        <!-- <el-table-column label="选课数量" align="center">
              <template slot-scope="scope">{{
                scope.row.chooseCourseNum
              }}</template>
            </el-table-column> -->

        <el-table-column label="缴费金额" align="center">
          <template slot-scope="scope">{{ scope.row.costMoney }}</template>
        </el-table-column>

        <!-- <el-table-column label="审课大学" align="center">
          <template slot-scope="scope">{{ scope.row.auditSchool }}</template>
        </el-table-column> -->

        <!-- <el-table-column label="LOP确认" align="center">
          <template slot-scope="scope">
            <el-button
              @click="confirm(scope.row.userCourseList)"
              type="mini"
              :disabled="scope.row.showConfirmDisabled"
              >确认</el-button
            >
          </template>
        </el-table-column> -->

        <!-- <el-table-column label="最近沟通记录" align="center">
                <template slot-scope="scope">{{ scope.row.context }}</template>
              </el-table-column> -->

        <!-- <el-table-column
                label="下次沟通时间"
                :sortable="'custom'"
                align="center"
                prop="nextChatTime"
              >
                <template slot-scope="scope">{{ scope.row.nextChatTime }}</template>
              </el-table-column> -->
      </el-table>
    </div>

    <div class="pagination-container">
      <el-pagination
        background
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        layout="total,sizes,prev, pager, next,jumper"
        :page-size="pageSize"
        :page-sizes="[5, 10, 15]"
        :current-page.sync="pageNum"
        :total="total"
      >
      </el-pagination>
    </div>
  </div>
</template>
<script>
import { auditFail, school, courseTime, LOPState } from "@/api/cso";
import { formatDate } from "@/utils/date";

const defaultListQuery = {
  pageNum: 1,
  pageSize: 10
};
export default {
  name: "auditFail",
  data() {
    return {
      listQuery: Object.assign({}, defaultListQuery),
      list: [],
      pageSize: null,
      pageNum: null,
      total: null,
      listLoading: true,
      multipleSelection: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            }
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            }
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            }
          }
        ]
      },
      inputTime: [],
      submitTime: [],
      paymentTime: [],
      schoolList: [],
      courseTimeList: [],
      passStateList: [
        {
          value: 1,
          label: "全部信息待确认"
        },
        {
          value: 2,
          label: "转学分待确认"
        },
        {
          value: 3,
          label: "已转学分"
        }
      ],
      isLopFile: false,
      isCreditFile: false,
      // checked: false,
      checkList: []
      //   showConfirm: true
    };
  },
  // computed: {
  //   starInputTime() {
  //     return this.inputTime[0]
  //   },
  //   endInputTime() {
  //     return this.inputTime[1]
  //   }
  // },
  watch: {
    inputTime(newValue, oldValue) {
      if (this.inputTime) {
        [
          this.listQuery.starInputTime,
          this.listQuery.endInputTime
        ] = this.inputTime;
      } else {
        this.listQuery.starInputTime = undefined;
        this.listQuery.endInputTime = undefined;
      }
    },
    submitTime(newValue, oldValue) {
      if (this.submitTime) {
        [this.listQuery.starTime, this.listQuery.endTime] = this.chatTime;
      } else {
        this.listQuery.starTime = undefined;
        this.listQuery.endTime = undefined;
      }
    },
    paymentTime(newValue, oldValue) {
      if (this.paymentTime) {
        [
          this.listQuery.starPaymentTime,
          this.listQuery.endPaymentTime
        ] = this.paymentTime;
      } else {
        this.listQuery.starPaymentTime = undefined;
        this.listQuery.endPaymentTime = undefined;
      }
    }
  },
  filters: {
    formatDateTime(time) {
      if (time == null || time === "") {
        return "N/A";
      }
      let date = new Date(time);
      // return formatDate(date, "yyyy-MM-dd hh:mm:ss");
      return formatDate(date, "yyyy-MM-dd");
    }
  },
  created() {
    this.getList();
    this.getSchool();
    this.getCourseTime();
  },

  methods: {
    test(aa) {
      if (this.userStatus == "") {
        this.userStatus = undefined;
      }
    },
    getList() {
      this.listLoading = true;
      auditFail(this.listQuery).then(res => {
        this.listLoading = false;
        this.pageNum = res.data.pageNum;
        this.pageSize = res.data.pageSize;
        this.total = res.data.total;

        this.list = JSON.parse(JSON.stringify(res.data.list));
        console.log(this.list, "this.list");
        this.$forceUpdate();
      });
    },
    getSchool() {
      school().then(res => {
        // this.schoolList = res.data;
        // console.log(this.schoolList, "this.schoolList");
        res.data.forEach(item => {
          let obj = {};
          obj.value = item;
          obj.label = item;
          this.schoolList.push(obj);
        });
      });
    },
    getCourseTime() {
      courseTime().then(res => {
        res.data.forEach(item => {
          let obj = {};
          obj.value = item;
          obj.label = item;
          this.courseTimeList.push(obj);
        });
      });
    },

    handleSearchList() {
      //搜索
      this.listQuery.pageNum = 1;
      this.getList();
    },
    handleAddProduct() {
      // 添加
      this.$router.push({ path: "/pms/addProduct" });
    },
    handleStuDetail(id) {
      // 测试用的
      this.$router.push({
        path: "/pms/stuDetail",
        query: {
          id: id
        }
      });
      // console.log(123);
    },

    handleCurrentChange(val) {
      // 翻页
      this.listQuery.pageNum = val;
      this.getList();
    },
    handleSizeChange(val) {
      //切换展示条数
      this.listQuery.pageSize = val;
      this.getList();
    },

    handleResetSearch(formName) {
      this.$refs[formName].resetFields();
      // 重置
      // this.selectProductCateValue = [];
      this.inputTime = undefined;
      this.isCreditFile = false;
      this.isLopFile = false;
      // this.chatTime = undefined;
      // this.paymentTime = undefined;
      this.listQuery = Object.assign({}, defaultListQuery);
      this.getList();
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    changeTableSort(column) {
      // console.log("prop", column.prop);
      // console.log("order", column.order);
      // console.log("column", column);
      if (column.prop == "addTime") {
        this.listQuery.secondSort = null;
        if (column.order == "ascending") {
          this.listQuery.firstSort = 0;
        } else if (column.order == "descending") {
          this.listQuery.firstSort = 1;
        }
      }
      if (column.prop == "commitTime") {
        this.listQuery.firstSort = null;
        if (column.order == "ascending") {
          this.listQuery.secondSort = 0;
        } else if (column.order == "descending") {
          this.listQuery.secondSort = 1;
        }
      }
      if (column.order == null) {
        this.listQuery.secondSort = this.listQuery.firstSort = null;
      }
      this.getList();
      console.log("changeTableSort");
    },
    confirm(userCourseList) {
      //   console.log(userCourseList, "userCourseList");
      let arr = [];
      userCourseList.forEach(item => {
        if (item.state2) {
          let obj = {};
          obj.id = item.id;
          obj.state = item.state2;
          arr.push(obj);
        }
      });
      if (arr.length == 0) {
        this.$message({
          type: "error",
          message: "请选择审课状态",
          duration: 1000
        });
      } else {
        this.$confirm("是否要确认", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(res => {
          LOPState(arr).then(res => {
            this.$message({
              type: "success",
              message: "提交成功",
              duration: 1000
            });

            this.getList();
            this.$forceUpdate();
          });
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.handleStuDetail {
  cursor: pointer;
}
.selectClass {
  display: flex;
  align-items: center;
  .el-select {
    width: 100px;
  }
}
</style>
